    PROGRAM f01edfe

!      F01EDF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : f01edf, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, lda, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F01EDF Example Program Results'
       WRITE (nout,*)
       FLUSH (nout)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       READ (nin,*) uplo
       lda = n
       ALLOCATE (a(lda,n))
!      Read A from data file
       IF (uplo=='U' .OR. uplo=='u') THEN
          READ (nin,*) (a(i,i:n),i=1,n)
       ELSE
          READ (nin,*) (a(i,1:i),i=1,n)
       END IF

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
!      Find exp( A )
       CALL f01edf(uplo,n,a,lda,ifail)

!      Print solution
       CALL x04caf(uplo,'N',n,n,a,lda,'Symmetric Exp(A)',ifail)

    END PROGRAM f01edfe
